# Zenodo entry for PredictMD

This document contains instructions for updating the Zenodo entry for PredictMD.

First go to [https://doi.org/10.5281/zenodo.1291209](https://doi.org/10.5281/zenodo.1291209), and then click on the yellow "Edit" button to edit the most recent release. Then, fill out the following fields with the specified values:

## Upload type:
Software

## Basic information

### Title:
PredictMD - Uniform interface for machine learning in Julia

### Authors:

| Name | Affiliation | ORCID |
| --- | -------- | ---- |
| Aluthge DP | Brown Center for Biomedical Informatics, Brown University | 0000-0002-9247-0530 |
| Sinha I | Brown Center for Biomedical Informatics, Brown University | 0000-0001-7796-819X |
| Stey P | Brown Center for Biomedical Informatics, Brown University | 0000-0003-2112-6756 |
| Restrepo MI | Brown Center for Biomedical Informatics, Brown University | 0000-0002-2708-8984 |
| Chen ES | Brown Center for Biomedical Informatics, Brown University | 0000-0002-6181-3369 |
| Sarkar IN | Brown Center for Biomedical Informatics, Brown University | 0000-0003-2054-7356 |

### Description:
PredictMD is a free and open-source Julia package that provides a uniform interface for machine learning.

### Language:
English

### Keywords:
* biomedical informatics
* Julia
* machine learning
* statistics

### Additional notes:
Development of PredictMD was supported in part by National Institutes of Health grants U54GM115677, R01LM011963, and R25MH116440. The content is solely the responsibility of the authors and does not necessarily represent the official views of the National Institutes of Health.

## License
MIT License

## Related/alternate identifiers

### Related identifiers:

(Replace `vMAJOR.MINOR.PATCH` with the appropriate version number. In our example, you would replace `vMAJOR.MINOR.PATCH` with `v3.6.0`.)

| Identifier | Relationship |
| ---- | ---- |
| `https://github.com/bcbi/PredictMD.jl/tree/vMAJOR.MINOR.PATCH` | is supplemented by this upload |
| `https://github.com/bcbi/PredictMD.jl/tree/vMAJOR.MINOR.PATCH` | is an alternate identifier of this upload |
| `https://github.com/bcbi/PredictMD.jl/releases/tag/vMAJOR.MINOR.PATCH` | is an alternate identifier of this upload |
| `https://predictmd.net/vMAJOR.MINOR.PATCH` | documents this upload |
| `https://predictmd.net` | compiled/created this upload |

After you have entered the correct information in all of the above fields, click the white "Save" button, and then click the blue "Publish" button. Congratulations, you are finished!

